import java.awt.*;
import java.lang.*;
import java.util.*;
import java.net.*;
import ControlFrame;
import ServerThreadSpy;
import ProxySessionInfo;

/**
 * finestra principale dell' HTTP Spy 
 */
public class HTTPSpy extends ControlFrame {
   /** Socket time out */
   public static final int SOCKET_TIMEOUT = 60000;
   /** porta del socket */
   public static final int SOCKET_PORT    = 8080;
   /** text area per i dati di input */
   private TextArea txtInput  = new TextArea("******** Dati di input ********");
   /** text area per i dati di output */
   private TextArea txtOutput = new TextArea("******** Dati di output ********");

   /** informazioni sulla connessione */
   private ProxySessionInfo proxySession = null;


   public HTTPSpy(ProxySessionInfo proxySession) {
      this.proxySession = proxySession;
      init();
   }


   /** 
    * inizializza i controlli
    */
   public void init() {
      setTitle("HTTP Spy Ver. 1.0 Copyright (c) Pietro Venanzangeli");
      setLayout(new GridLayout(2,1));
      //txtInput.setEnabled( false );
      //txtOutput.setEnabled( false );
      add(txtInput);
      add(txtOutput);
      /** esegue il servizio di spy */
      System.out.println("esegue il servizio di spy");
      new ServerThreadSpy(this,proxySession).start();
   }


   /**
    * scrive i dati nella finestra di input
    * @param sTemp e' la stringa da visualizzare
    */
   public synchronized void inputRequest( String sTemp ){
      txtInput.append(sTemp);
   }

   /**
   * scrive i dati nella finestra di output
   * @param sTemp e' la stringa da visualizzare
   */
   public synchronized void outputRequest( String sTemp ){
      txtOutput.append(sTemp);
   }



   /**
    * punto di ingresso dell' SpyHTTP
    * deve essere specificato il server proxy e la porta del server
    */
   public static void main(String args[]){
      if (args.length == 2) {
         try {
            HTTPSpy mySpy = new HTTPSpy(new ProxySessionInfo(args[0],new Integer(args[1]).intValue()));
            mySpy.setSize(400,400);
            mySpy.setVisible(true);
         } catch (Exception e) {
            System.out.println("Numero di parametri non valido\n\r sintassi : programma < PROXY SERVER > < PORTA >");
         }
      } else {
         System.out.println("Numero di parametri non valido\n\r sintassi : programma < PROXY SERVER > < PORTA >");
      }

   }

}













