
import java.awt.*;
import java.lang.*;
import java.util.*;
import java.net.*;
import ProxySessionInfo;
import clientThreadSpy;

/**
 * crea il socket e instanzia il server
 */
public class ServerThreadSpy extends Thread {

   /** ferma il servizio */
   public static boolean signal = true;
   /** istanza della classe padre */
   private  HTTPSpy spy;
   /** server socket */
   private  ServerSocket srvSocket = null;
   /** informazioni sul proxy da utlizzare */
   private  ProxySessionInfo proxySession = null;


   /**
    * crea il server
    * @param spy e' l'istanza della classe padre
    * @param proxySession contiene le informazioni sul proxy da utilizzare
    */
   public ServerThreadSpy(HTTPSpy spy,ProxySessionInfo proxySession) {
      this.spy = spy;
      this.proxySession = proxySession;

   }

   public void run() {
      try {
         srvSocket = new ServerSocket(HTTPSpy.SOCKET_PORT);
         while (signal) {
            Socket s = srvSocket.accept();
            new clientThreadSpy(this,proxySession,s).start();
         }
      } catch (Exception e) {
         e.printStackTrace();
      }
      terminate();
   }

   /**
    * chiude la connessione del server
    */
   private void terminate() {
      try {
         srvSocket.close();
      } catch (Exception e) {
         e.printStackTrace();
      }
   }


   /**
    * scrive i dati nella finestra di input
    * @param sTemp e' la stringa da visualizzare
    */
   public void inputRequest( String sTemp ) {
      spy.inputRequest("\n*************** RICHIESTA *****************\n");
      spy.inputRequest(sTemp);
   }

   /**
    * scrive i dati nella finestra di input
    * @param sTemp e' la stringa da visualizzare
    */
   public void outputRequest( String sTemp ){
      spy.outputRequest("\n*************** RISPOSTA *****************\n");
      spy.outputRequest(sTemp);
   }

}

